Given a set of positive integers. find the maximum XOR subset value in the given set. Expected time complexity O(n).
Examples:
Input: set[] = {2, 4, 5}
Output: 7
The subset {2, 5} has maximum XOR value
Input: set[] = {9, 8, 5}
Output: 13
The subset {8, 5} has maximum XOR value
Input: set[] = {8, 1, 2, 12, 7, 6}
Output: 15
The subset {1, 2, 12} has maximum XOR value
Input: set[] = {4, 6}
Output: 6
The subset {6} has maximum XOR value
Note: This problem is different from the maximum subarray XOR. Here we need to find a subset instead of a subarray.
A Simple Solution is to generate all possible subsets of given set, find XOR of every subset and return the subset with maximum XOR.
Below is an Efficient Algorithm that works in O(n) time. The idea is based on below facts:
- Number of bits to represent all elements is fixed which is 32 bits for integer in most of the compilers.
- If maximum element has Most Significant Bit MSB at position i, then result is at least 2i
1. Initialize index of chosen elements as 0. Let this index be
'index'
2. Traverse through all bits starting from most significant bit.
Let i be the current bit.
......(a) Find the maximum element with i'th bit set. If there
is no element with i'th bit set, continue to smaller
bit.
......(b) Let the element with i'th bit set be maxEle and index
of this element be maxInd. Place maxEle at 'index' and
(by swapping set[index] and set[maxInd])
......(c) Do XOR of maxEle with all numbers having i'th bit as set.
......(d) Increment index
3. Return XOR of all elements in set[]. Note that set[] is modified
in step 2.c.
Below is the implementation of this algorithm.
C++
#include<bits/stdc++.h>
using namespace std;
#define INT_BITS 32
int maxSubsetXOR( int set[], int n)
{
int index = 0;
for ( int i = INT_BITS-1; i >= 0; i--)
{
int maxInd = index;
int maxEle = INT_MIN;
for ( int j = index; j < n; j++)
{
if ( (set[j] & (1 << i)) != 0
&& set[j] > maxEle )
maxEle = set[j], maxInd = j;
}
if (maxEle == INT_MIN)
continue ;
swap(set[index], set[maxInd]);
maxInd = index;
for ( int j=0; j<n; j++)
{
if (j != maxInd &&
(set[j] & (1 << i)) != 0)
set[j] = set[j] ^ set[maxInd];
}
index++;
}
int res = 0;
for ( int i = 0; i < n; i++)
res ^= set[i];
return res;
}
int main()
{
int set[] = {9, 8, 5};
int n = sizeof (set) / sizeof (set[0]);
cout << "Max subset XOR is " ;
cout << maxSubsetXOR(set, n);
return 0;
}
|
Java
import java.util.*;
class GFG {
static final int INT_BITS = 32 ;
static int maxSubarrayXOR( int set[], int n)
{
int index = 0 ;
for ( int i = INT_BITS - 1 ; i >= 0 ; i--)
{
int maxInd = index;
int maxEle = Integer.MIN_VALUE;
for ( int j = index; j < n; j++) {
if ((set[j] & ( 1 << i)) != 0 && set[j] > maxEle)
{
maxEle = set[j];
maxInd = j;
}
}
if (maxEle == - 2147483648 )
continue ;
int temp = set[index];
set[index] = set[maxInd];
set[maxInd] = temp;
maxInd = index;
for ( int j = 0 ; j < n; j++) {
if (j != maxInd && (set[j] & ( 1 << i)) != 0 )
set[j] = set[j] ^ set[maxInd];
}
index++;
}
int res = 0 ;
for ( int i = 0 ; i < n; i++)
res ^= set[i];
return res;
}
public static void main(String arg[]) {
int set[] = { 9 , 8 , 5 };
int n = set.length;
System.out.print( "Max subset XOR is " );
System.out.print(maxSubarrayXOR(set, n));
}
}
|
Python3
INT_BITS = 32
def maxSubarrayXOR( set ,n):
index = 0
for i in range (INT_BITS - 1 , - 1 , - 1 ):
maxInd = index
maxEle = - 2147483648
for j in range (index,n):
if ( ( set [j] & ( 1 << i)) ! = 0
and set [j] > maxEle ):
maxEle = set [j]
maxInd = j
if (maxEle = = - 2147483648 ):
continue
temp = set [index]
set [index] = set [maxInd]
set [maxInd] = temp
maxInd = index
for j in range (n):
if (j ! = maxInd and
( set [j] & ( 1 << i)) ! = 0 ):
set [j] = set [j] ^ set [maxInd]
index = index + 1
res = 0
for i in range (n):
res = res ^ set [i]
return res
set = [ 9 , 8 , 5 ]
n = len ( set )
print ( "Max subset XOR is " ,end = "")
print (maxSubarrayXOR( set , n))
|
C#
using System;
class GFG
{
static int INT_BITS = 32;
static int maxSubarrayXOR( int [] set ,
int n)
{
int index = 0;
for ( int i = INT_BITS - 1;
i >= 0; i--)
{
int maxInd = index;
int maxEle = int .MinValue;
for ( int j = index; j < n; j++)
{
if (( set [j] & (1 << i)) != 0 &&
set [j] > maxEle)
{
maxEle = set [j];
maxInd = j;
}
}
if (maxEle == -2147483648)
continue ;
int temp = set [index];
set [index] = set [maxInd];
set [maxInd] = temp;
maxInd = index;
for ( int j = 0; j < n; j++)
{
if (j != maxInd && ( set [j] &
(1 << i)) != 0)
set [j] = set [j] ^ set [maxInd];
}
index++;
}
int res = 0;
for ( int i = 0; i < n; i++)
res ^= set [i];
return res;
}
public static void Main()
{
int [] set = {9, 8, 5};
int n = set .Length;
Console.Write( "Max subset XOR is " );
Console.Write(maxSubarrayXOR( set , n));
}
}
|
Javascript
<script>
let INT_BITS = 32;
function maxSubarrayXOR(set,n)
{
let index = 0;
for (let i = INT_BITS - 1; i >= 0; i--)
{
let maxInd = index;
let maxEle = Number.MIN_VALUE;
for (let j = index; j < n; j++) {
if ((set[j] & (1 << i)) != 0 && set[j] > maxEle)
{
maxEle = set[j];
maxInd = j;
}
}
if (maxEle == Number.MIN_VALUE)
continue ;
let temp = set[index];
set[index] = set[maxInd];
set[maxInd] = temp;
maxInd = index;
for (let j = 0; j < n; j++) {
if (j != maxInd && (set[j] & (1 << i)) != 0)
set[j] = set[j] ^ set[maxInd];
}
index++;
}
let res = 0;
for (let i = 0; i < n; i++)
res ^= set[i];
return res;
}
let set=[9, 8, 5];
let n = set.length;
document.write( "Max subset XOR is " );
document.write(maxSubarrayXOR(set, n));
</script>
|
PHP
<?php
$INT_BITS = 32;
function maxSubarrayXOR(& $set , $n )
{
global $INT_BITS ;
$index = 0;
for ( $i = $INT_BITS - 1; $i >= 0; $i --)
{
$maxInd = $index ;
$maxEle = 0;
for ( $j = $index ; $j < $n ; $j ++)
{
if ( ( $set [ $j ] & (1 << $i )) != 0 &&
$set [ $j ] > $maxEle )
{
$maxEle = $set [ $j ];
$maxInd = $j ;
}
}
if ( $maxEle == 0)
continue ;
$t = $set [ $index ];
$set [ $index ] = $set [ $maxInd ];
$set [ $maxInd ] = $t ;
$maxInd = $index ;
for ( $j = 0; $j < $n ; $j ++)
{
if ( $j != $maxInd &&
( $set [ $j ] & (1 << $i )) != 0)
$set [ $j ] = $set [ $j ] ^ $set [ $maxInd ];
}
$index ++;
}
$res = 0;
for ( $i = 0; $i < $n ; $i ++)
$res ^= $set [ $i ];
return $res ;
}
$set = array (9, 8, 5);
$n = sizeof( $set );
echo "Max subset XOR is " ;
echo maxSubarrayXOR( $set , $n );
?>
|
Output:
Max subset XOR is 13
Time Complexity: O(n)
Auxiliary Space: O(1)
Illustration:
Let the input set be : {9, 8, 5}
We start from 31st bit [Assuming Integers are 32 bit
long]. The loop will continue without doing anything till 4'th bit.
The 4th bit is set in set[0] i.e. 9 and this is the maximum
element with 4th bit set. So we choose this element and check
if any other number has the same bit set. If yes, we XOR that
number with 9. The element set[1], i.e., 8 also has 4'th bit
set. Now set[] becomes {9, 1, 5}. We add 9 to the list of
chosen elements by incrementing 'index'
We move further and find the maximum number with 3rd bit set
which is set[2] i.e. 5 No other number in the array has 3rd
bit set. 5 is also added to the list of chosen element.
We then iterate for bit 2 (no number for this) and then for
1 which is 1. But numbers 9 and 5 have the 1st bit set. Thus
we XOR 9 and 5 with 1 and our set becomes (8, 1, 4)
Finally, we XOR current elements of set and get the result
as 8 ^ 1 ^ 4 = 13.
Using BitMasking:
Approach:
We first find the maximum number in the input list nums using the built-in max function.
If the maximum number is 0, it means that all the numbers in the list are also 0, and so the maximum XOR value will also be 0. So we return 0.
Otherwise, we calculate the maximum bit position of the maximum number using the math.log2 function.
We initialize the ans variable to 0, which will eventually hold the maximum XOR value we find.
We also initialize a mask variable to 0, which we will use to generate a set of prefixes for each bit position.
We loop through the bit positions in descending order from the maximum bit position to 0.
In each iteration, we set the mask variable to the current bit position by left-shifting 1 by the bit position and subtracting 1. For example, if the bit position is 2, mask will be set to 0b00000100.
We generate a set of prefixes for the current bit position by applying the mask to each number in the input list using the bitwise AND operator (&). This results in a set of numbers where the rightmost bits up to the current bit position are all 0.
We initialize a candidate variable to the current ans value with the bit at the current bit position set to 1 using the bitwise OR operator (|).
We loop through each prefix in the set of prefixes we generated in step 8.
For each prefix, we check if there exists another prefix in the set that, when XORed with the candidate variable, results in another prefix in the set. If such a prefix exists, it means that we can use the candidate variable as the new ans value, since it indicates that we can form a larger XOR value by setting the bit at the current bit position to 1.
If we find such a prefix, we set the ans variable to the candidate value and break out of the loop.
We return the ans variable at the end of the loop, which should contain the maximum XOR value we found.
C++
#include <bits/stdc++.h>
using namespace std;
int findMaximumXOR( int nums[], int n) {
int result = 0;
int mask = 0;
for ( int i=31;i>=0;i--){
mask = mask | (1<<i);
int candidateResult = result | (1<<i);
unordered_set< int > set;
for ( int j=0; j<n; j++){
set.insert(nums[j] & mask);
}
for ( int prefix : set){
if (set.find(candidateResult^prefix) != set.end()){
result = candidateResult;
break ;
}
}
}
return result;
}
int main() {
int set[] = {9, 8, 5};
int n = sizeof (set)/ sizeof (set[0]);
cout << "Max subset XOR is " << findMaximumXOR(set,n);
}
|
Java
import java.util.*;
class Solution {
public static int findMaximumXOR( int [] nums) {
int result = 0 ;
int mask = 0 ;
for ( int i= 31 ;i>= 0 ;i--){
mask = mask | ( 1 <<i);
int candidateResult = result | ( 1 <<i);
HashSet<Integer> set = new HashSet<>();
for ( int num : nums){
set.add(num & mask);
}
for ( int prefix : set){
if (set.contains(candidateResult^prefix)){
result = candidateResult;
break ;
}
}
}
return result;
}
public static void main(String arg[]) {
int set[] = { 9 , 8 , 5 };
System.out.print( "Max subset XOR is " );
System.out.print(findMaximumXOR(set));
}
}
|
Python
class Solution:
@staticmethod
def findMaximumXOR(nums):
result = 0
mask = 0
for i in range ( 31 , - 1 , - 1 ):
mask = mask | ( 1 << i)
candidateResult = result | ( 1 << i)
s = set ()
for num in nums:
s.add(num & mask)
for prefix in s:
if (candidateResult ^ prefix) in s:
result = candidateResult
break
return result
if __name__ = = '__main__' :
set_ = [ 9 , 8 , 5 ]
print ( "Max subset XOR is " , Solution.findMaximumXOR(set_))
|
C#
using System;
using System.Collections.Generic;
public class MaximumXORFinder
{
public static int FindMaximumXOR( int [] nums, int n)
{
int result = 0;
int mask = 0;
for ( int i = 31; i >= 0; i--)
{
mask = mask | (1 << i);
int candidateResult = result | (1 << i);
HashSet< int > set = new HashSet< int >();
for ( int j = 0; j < n; j++)
{
set .Add(nums[j] & mask);
}
foreach ( int prefix in set )
{
if ( set .Contains(candidateResult ^ prefix))
{
result = candidateResult;
break ;
}
}
}
return result;
}
public static void Main( string [] args)
{
int [] set = { 9, 8, 5 };
int n = set .Length;
Console.WriteLine( "Max subset XOR is " + FindMaximumXOR( set , n));
}
}
|
Javascript
function findMaximumXOR(nums) {
let result = 0;
let mask = 0;
for (let i = 31; i >= 0; i--) {
mask = mask | (1 << i);
const candidateResult = result | (1 << i);
const set = new Set();
for (let j = 0; j < nums.length; j++) {
set.add(nums[j] & mask);
}
for (const prefix of set) {
if (set.has(candidateResult ^ prefix)) {
result = candidateResult;
break ;
}
}
}
return result;
}
const set = [9, 8, 5];
console.log( "Max subset XOR is" , findMaximumXOR(set));
|
Output
Max subset XOR is 13
Time Complexity : O(nxlogm)
How does this work?
Let us first understand a simple case when all elements have Most Significant Bits (MSBs) at different positions. The task in this particular case is simple, we need to do XOR of all elements.
If the input contains multiple numbers with the same MSB, then it’s not obvious which of them we should choose to include in the XOR. What we do is reduce the input list into an equivalent form that doesn’t contain more than one number of the same length. By taking the maximum element, we know that the MSB of this is going to be there in output. Let this MSB be at position i. If there are more elements with i’th set (or same MSB), we XOR them with the maximum number so that the i’th bit becomes 0 in them and the problem reduces to i-1 bits.
Note: The above method is similar to Gaussian elimination. Consider a matrix of size 32 x n where 32 is number of bits and n is number of elements in array.
This article is contributed by Ekta Goel. Please write comments if you find anything incorrect, or you want to share more information about the topic discussed above.